import sys
import time
import random

import dds

recv = ['send', 'recv'].index(sys.argv[1])

d = dds.DDS(28)
l = dds.Library('./ShapeType.dll')

t = d.get_topic('Square', l.ShapeType )
mf = lambda : dict(color=str("BLUE"), x=10, y=10, shapesize=10)

i = 0


if recv:
    while True:
        time.sleep(.01)
        
        try:
            msg = t.recv()
        except dds.Error, e:
            if e.message == 'no data':
                continue
            raise
        print "Received %r on %s" % (msg, t.name)
        print "color: %s" % (msg['color'])
        print "x: %s" % (msg['x'])
        print "y: %s" % (msg['y'])
        print "shapesize: %s" % (msg['shapesize'])
		
else:
    while True:
        mf = lambda : dict(color=str("BLUE"), x=10+i, y=10+i, shapesize=10)
        msg = mf()
        print "Sending %r on %s" % (msg, t.name)
        t.send(msg)
        time.sleep(.1)
        i = i + 1

